import random as rm

#с читабельностью беда будет

class Game:
	
	def __init__(self):
		self.enemys = []
		for i in range(3):
			self.enemys.append(Enemy(9, 9))
		self.player = Player(9, 15)
		self.score = 0
		self.live = 3
		self.powerupTimer = 0
		self.freezeTimer = 0
	
	#основной цикл
	def run(self):
		
		self.draw()
		
		while True:
			
			self.playerMove()
			
			#проверка столкновения с врагами
			for i in self.enemys:
				if (i.x, i.y) == (self.player.x, self.player.y):
					if self.powerupTimer > 0:
						i.x, i.y = 9, 9
						self.score += 5
					else:
						self.live -= 1
						self.enemys = []
						for i in range(3):
							self.enemys.append(Enemy(9, 9))
						self.player = Player(9, 15)


			#луз
			if self.live == 0:
				print("\n" * 5)
				print("Вы проиграли")
				print(f"Вы набрали {self.score} очков")
				print("\n" * 10)
				break
			
			#подбираемые предметы
			if tileMap[self.player.x, self.player.y] == "coin":
				self.score += 1
				tileMap[self.player.x, self.player.y] = "pusto"
			elif tileMap[self.player.x, self.player.y] == "powerup":
				self.powerupTimer = 30
				tileMap[self.player.x, self.player.y] = "pusto"
			elif tileMap[self.player.x, self.player.y] == "freeze":
				self.freezeTimer = 30
				tileMap[self.player.x, self.player.y] = "pusto"

			# вин
			for i in tileMap:
				if tileMap[i] == "coin":
					break
			else:
				print("\n" * 5)
				print("Вы собрали все монетки")
				print("\n" * 10)
				break
			
			#таймеры
			if self.freezeTimer == 0:
				self.enemyMove()
			else:
				self.freezeTimer -= 1
			
			if self.powerupTimer > 0:
				self.powerupTimer -= 1
			
			self.draw()
		
		
	#вывод в консоль карты и описания
	def draw(self):
		print("\n" * 5)
		for inum, i in enumerate(map):
			for xnum, x in enumerate(i):
				if (xnum, inum) == (self.player.x, self.player.y):
					print("@", end=" ")
					continue
				for z in self.enemys:
					if (z.x, z.y) == (xnum, inum):
						print("Ж", end=" ")
						break
				else:
					if tileMap[xnum, inum] == "pusto":
						print(" ", end=" ")
					else:
						if x == "O":
							print(".", end=" ")
						elif x == "#":
							print("#", end=" ")
						elif x == "G":
							print("o", end=" ")
						elif x == "F":
							print("*", end=" ")
						else:
							print(" ", end=" ")
			if inum == 2:
				if self.powerupTimer > 0:
					print(f"Неуязвимость : {self.powerupTimer}", end="")
			if inum == 3:
				if self.freezeTimer > 0:
					print(f"Заморозка : {self.freezeTimer}", end="")
			print("")
		print(f"Очки : {self.score}\t Жизни : {self.live}\n\nУправление:	| Инфо:\nц / w - вверх	| # - стена	o - неуязвимость\nы / s - вниз	| . - монетка	* - заморозка\nф / a - влево	| Ж - враги\nв / d - вправо	| @ - игрок\n")
	
	#выбор движения игрока
	def playerMove(self):
		while True:
			inp = input("Куда идём? : ")
			if inp in ["w", "d", "s", "a"]:
				self.move(self.player, inp)
			else:
				print("Неизвестный ход")
				continue
			break
	
	#рандомное движение врагов
	def enemyMove(self):
		for i in self.enemys:
			if rm.randint(1, 4) == 1:
				i.moving = rm.choice(["ц", "ф", "в", "ы"])
			elif i.last == [i.x, i.y]:
				i.moving = rm.choice(["ц", "ф", "в", "ы"])
			i.last = [i.x, i.y]
			self.move(i, i.moving)
	
	#движение обьектов
	def move(self, body, way):
		try:
			if way == "ы" or way == "s":
				if tileMap[body.x, body.y + 1] != "wall":
					body.y += 1
			elif way == "ц" or way == "w":
				if tileMap[body.x, body.y - 1] != "wall":
					body.y -= 1
			elif way == "в" or way == "d":
				if tileMap[body.x + 1, body.y] != "wall":
					body.x += 1
			elif way == "ф" or way == "a":
				if tileMap[body.x - 1, body.y] != "wall":
					body.x -= 1
		except:
			#костыль
			if body.x == 0:
				body.x = 18
			elif body.x == 18:
				body.x = 0


class Player:
		
	def __init__(self, x, y):
		self.x = x
		self.y = y
		

class Enemy:
	
	def __init__(self, x, y):
		self.x = x
		self.y = y
		self.moving = "н"
		self.last = [self.x, self.y]

#карта из пакмана
map = ["###################", "#GOOOOOOO#OOOOOOOG#", "#O##O###O#O###O##O#", "#OOOOOOOOOOOOOOOOO#", "#O##O#O#####O#O##O#", "#OOOO#OOO#OOO#OOOO#", "####O###P#P###O####", "####F#PPPPPPP#O####", "####O#PP#P#PP#O####", "OOOOOPPP#P#PPPOOOOO", "####O#PP###PP#O####", "####O#PPPPPPP#F####", "####O#P#####P#O####", "#OOOOOOOO#OOOOOOOO#", "#O##O###O#O###O##O#", "#OO#OOOOOPOOOOO#OO#", "##O#O#O#####O#O#O##", "#OOOO#OOO#OOO#OOOO#", "#O######O#O######O#", "#GOOOOOOOOOOOOOOOG#", "###################"]

#словарь с координатами и типами клеток
tileMap = {}

#заполнение словаря по карте и сброс при игре снова
def mapReset():
		global tileMap
		tileMap ={}
		for inum, i in enumerate(map):
			for xnum, x in enumerate(i):
				if x == "#":
					tileMap[xnum, inum] = "wall"
				if x == "O":
					tileMap[xnum, inum] = "coin"
				if x == "P":
					tileMap[xnum, inum] = "pusto"
				if x == "G":
					tileMap[xnum, inum] = "powerup"
				if x == "F":
					tileMap[xnum, inum] = "freeze"
				




def main():
	mapReset()
	game = Game()
	while True:
		while True:
			
			game.run()
			while True:
				again = input("Хoтите сыграть снoва? (да/нет): ").lower()
				if again == "да" or again == "нет":
					break
				else:
					print("Неизвестный ответ")
		
		if again == "да":
			mapReset()
			game = Game()
			continue
		else:
			exit()
		


if __name__ == "__main__":
		main()
		